
/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "system\typedefs.h"
#include "system\usb\usb.h"
#include "io_cfg.h"
#include "user\boot.h"

#if defined(USB_USE_HID)                // See autofiles\usbcfg.h

/** V A R I A B L E S ********************************************************/
#pragma udata

byte byteTemp;
byte trf_state;

word big_counter;

volatile far BOOT_DATA_PACKET dataPacket;


/** P R I V A T E  P R O T O T Y P E S ***************************************/


/** D E C L A R A T I O N S **************************************************/
#pragma code

/** C L A S S  S P E C I F I C  R E Q ****************************************/

/** U S E R  A P I ***********************************************************/


void ReadSwitch_SW3(void)
{
    if(!sw3) {
      dataPacket.data[0] = 0x22;
      dataPacket.data[1] = 0x55;
      //dataPacket._byte[0] = 0x22;
      //dataPacket._byte[1] = 0x55;
    }else{
      dataPacket.data[0] = 0x00;
      dataPacket.data[1] = 0x55;
      //dataPacket._byte[0] = 0x00;
      //dataPacket._byte[1] = 0x55;
    }
}


void BootService (void) {

    if (HIDRxReport(dataPacket._byte, EP1_BUF_SIZE) > 0) // USB receive buffer has data
    {
        switch(dataPacket.CMD)
        {
            case READ_SW3:
                ReadSwitch_SW3();
                while(mHIDTxIsBusy()){}                 // blocking
                HIDTxReport(dataPacket._byte, EP1_BUF_SIZE);   // transmit packet

                break;

            case LEDS_ON:
                mLED_1_On();
                mLED_2_On();
                mLED_3_On();
                mLED_4_On();

                //while(mHIDTxIsBusy()){}                 // blocking
                //HIDTxReport(dataPacket._byte, EP1_BUF_SIZE);   // transmit packet

                break;

            case LEDS_OFF:
                mLED_1_Off();
                mLED_2_Off();
                mLED_3_Off();
                mLED_4_Off();

                //while(mHIDTxIsBusy()){}                 // blocking
                //HIDTxReport(dataPacket._byte, EP1_BUF_SIZE);   // transmit packet

                break;

            case RESET:
                USBSoftDetach();
                big_counter = 0;
                while(--big_counter) {
                    Nop();
                    Nop();
                }
                Reset();
                break;

            default:                // unknown command - ignore
                break;

        }//end switch()
    }//end if

}//end BootService

#endif

/** EOF boot.c ***************************************************************/
